﻿Public Class EncryptionForm
    ' Encrypts a character by returning it symmetric counterpart. For example,
    ' if the character is 'A' then it returns 'Z'. Similarly if the character
    ' is '0' it returns '9'.
    Private Function EncryptCharacter(ByVal unencryptedChar As Char) As Char
        Dim encryptedChar As Char

        If Char.IsLower(unencryptedChar) Then
            encryptedChar = Convert.ToChar(Asc("n"c) + Asc("m"c) - Asc(unencryptedChar))
        ElseIf Char.IsUpper(unencryptedChar) Then
            encryptedChar = Convert.ToChar(Asc("N"c) + Asc("M"c) - Asc(unencryptedChar))
        ElseIf Char.IsDigit(unencryptedChar) Then
            encryptedChar = Convert.ToChar(Asc("5"c) + Asc("4"c) - Asc(unencryptedChar))
        End If

        Return encryptedChar
    End Function

    ' Initiates the encryption.
    Private Sub encryptButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles encryptButton.Click
        Dim unencryptedString As String = String.Empty
        Dim encryptedString As String = String.Empty

        ' Save the input string.
        unencryptedString = unencryptedTextBox.Text

        ' Traverses each character in the string and encrypts it. It then adds
        ' this encrypted character to a string. Thus, building up an encrypted
        ' string.
        For i = 0 To unencryptedString.Length - 1
            encryptedString &= EncryptCharacter(unencryptedString.Chars(i)).ToString
        Next

        ' Disply encrypted string.
        encryptedLabel.Text = encryptedString

        ' Selected entire entry in input textbox.
        unencryptedTextBox.SelectAll()
    End Sub

    ' Each time a character is entered in the input textbox, clear the 
    ' output textbox.
    Private Sub unencryptedTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles unencryptedTextBox.TextChanged
        encryptedLabel.Text = String.Empty
    End Sub
End Class
