﻿Public Class Form1
    Private rectWidth As Integer = 160
    Private rectHeight As Integer = 160
    Private rectLeft As Integer = 100
    Private rectTop As Integer = 100


    Private Sub DrawOuterPentagon(ByVal g As Graphics)
        Dim r As Integer = rectWidth \ 2
        Dim cx As Integer = rectLeft + r
        Dim cy As Integer = rectTop + r

        Dim theta As Double = Math.PI / 2
        Dim dtheta As Double = Math.PI * 0.4

        Dim pentagon(5) As Point

        For i = 0 To 5
            pentagon(i).X = cx + CInt(r * Math.Cos(theta))
            pentagon(i).Y = cy - CInt(r * Math.Sin(theta))
            theta += dtheta
        Next

        g.DrawLines(Pens.Red, pentagon)
    End Sub


   

    Private Sub DrawInnerPentagon(ByVal g As Graphics)
        Dim r As Integer = rectWidth \ 2
        Dim r2 As Integer = CInt(r * 0.5)

        Dim cx As Integer = rectLeft + r
        Dim cy As Integer = rectTop + r

        Dim theta As Double = -Math.PI / 2
        Dim dtheta As Double = Math.PI * 0.4

        Dim pentagon(5) As Point

        For i = 0 To 5
            pentagon(i).X = cx + CInt(r2 * Math.Cos(theta))
            pentagon(i).Y = cy - CInt(r2 * Math.Sin(theta))
            theta += dtheta
        Next

        g.DrawLines(Pens.Blue, pentagon)
    End Sub



    Private Sub DrawFivePointStar(ByVal g As Graphics)
        Dim r1 As Integer = rectWidth \ 2
        Dim r2 As Integer = CInt(r1 * 0.4)
        Dim r As Integer

        Dim cx As Integer = rectLeft + r1
        Dim cy As Integer = rectTop + r1

        Dim theta As Double = Math.PI / 2
        Dim dtheta As Double = Math.PI * 0.2

        Dim star(10) As Point

        For i = 0 To 10
            If i Mod 2 = 0 Then r = r1 Else r = r2

            star(i).X = cx + CInt(r * Math.Cos(theta))
            star(i).Y = cy - CInt(r * Math.Sin(theta))
            theta += dtheta
        Next

        g.FillPolygon(New SolidBrush(Color.Olive), star)

    End Sub



    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        Dim g As Graphics = e.Graphics

        ' How about smoothing the lines a bit.
        'g.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias

        g.DrawRectangle(Pens.Black, rectLeft, rectTop, rectWidth, rectHeight)
        g.DrawEllipse(Pens.Blue, rectLeft, rectTop, rectWidth, rectHeight)

        DrawOuterPentagon(g)
        DrawInnerPentagon(g)
        DrawFivePointStar(g)


    End Sub
End Class
