﻿Public Class GraphicsPath
    ' In this version, I will simply draw lines, although any shape can be
    ' added to the graphicsPath.

    Private shouldDraw As Boolean
    Private shouldSelect As Boolean
    Private g As Graphics
    Private path As New Drawing2D.GraphicsPath
    Private startLine As Point
    Private endLine As Point


    Private Sub GraphicsPath_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        If shouldSelect Then
            ' Since we are looking for lines, use IsOutlineVisible(), but
            ' if you have other types of objects, use IsVisible().
            Dim mp As Point = Me.PointToClient(MousePosition)
            Dim pts() As PointF = path.PathPoints()
            Dim pen As Pen

            If path.IsOutlineVisible(mp, Pens.Blue) Then
                ' Highlight the entire path.
                pen = New Pen(Color.Red, 5.0)
                Me.Text = "GraphicsPath - Select Mode (" & path.PointCount & ")"
            Else
                ' Clicked off the path, so repaint with original drawing color.
                pen = New Pen(Color.Blue, 5.0)
                Me.Text = "GraphicsPath - Select Mode"
            End If

            For i = 0 To pts.Count - 2 Step 2
                g.DrawLine(pen, pts(i), pts(i + 1))
            Next
        End If
    End Sub


    Private Sub GraphicsPath_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        g = Me.CreateGraphics
    End Sub


    Private Sub GraphicsPath_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left AndAlso shouldDraw Then
            startLine = e.Location
            endLine = e.Location
        End If
    End Sub

    Private Sub GraphicsPath_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        If e.Button = Windows.Forms.MouseButtons.Left AndAlso shouldDraw Then
            g.DrawLine(New Pen(SystemColors.Control, 5.0), startLine, endLine)
            endLine = e.Location
            g.DrawLine(New Pen(Color.Blue, 5.0), startLine, endLine)
            g.DrawPath(New Pen(Color.Blue, 5.0), path)
        End If
    End Sub

    Private Sub GraphicsPath_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        If shouldDraw Then
            ' We are done drawing, so add the line to the path.
            path.StartFigure()
            path.AddLine(startLine, endLine)
            g.DrawPath(New Pen(Color.Blue, 5.0), path)
        End If
    End Sub


    Private Sub GraphicsPath_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        'g.DrawPath(New Pen(Color.Blue, 5.0), path)
    End Sub

    Private Sub selectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles selectButton.Click
        ' Indicate we are selecting
        shouldSelect = True
        shouldDraw = False
        Me.Text = "GraphicsPath - Select Mode"
    End Sub

    Private Sub drawButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles drawButton.Click
        shouldDraw = True
        shouldSelect = False
        Me.Text = "GraphicsPath - Draw Mode"
    End Sub
End Class