﻿Public Class RectangleForm
    Private shouldDraw As Boolean
    Private shouldSelect As Boolean
    Private g As Graphics
    Private rects() As Rectangle
    Private selectedRectIndex As Integer = -1


    Private Sub RectangleForm_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        If shouldSelect Then
            ' If a rectangle is already selected, unselect it.
            If selectedRectIndex <> -1 Then
                g.FillRectangle(Brushes.Bisque, rects(selectedRectIndex))
                selectedRectIndex = -1
            End If

            ' Let' see if we can identify which rectangle was clicked.
            For index = 0 To rects.GetUpperBound(0)
                If rects(index).Contains(Me.PointToClient(MousePosition)) Then
                    ' Track current selection.
                    selectedRectIndex = index

                    ' Select current rectangle.
                    g.FillRectangle(New SolidBrush(Color.FromArgb(65, 160, 130, 170)), rects(selectedRectIndex))
                End If
            Next
        End If
    End Sub


    Private Sub RectangleForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        g = Me.CreateGraphics
    End Sub


    Private Sub RectangleForm_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left AndAlso shouldDraw Then
            If rects IsNot Nothing Then
                ReDim Preserve rects(rects.GetUpperBound(0) + 1)
            Else
                ReDim rects(0)
            End If
            rects(rects.GetUpperBound(0)) = New Rectangle(e.X, e.Y, 1, 1)
        End If
    End Sub

    Private Sub RectangleForm_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        If e.Button = Windows.Forms.MouseButtons.Left AndAlso shouldDraw Then
            g.FillRectangle(SystemBrushes.Control, rects(rects.GetUpperBound(0)))
            With rects(rects.GetUpperBound(0))
                .Width = e.X - .X
                .Height = e.Y - .Y
            End With
            g.FillRectangle(Brushes.Bisque, rects(rects.GetUpperBound(0)))
        End If
    End Sub


    Private Sub RectangleForm_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        ' Side note: If a rectangle is selected and then mouse moves over 
        ' either of the two buttons, this event is called. I am not sure
        ' why.

        ' Repaint if form is resized or covered.
        If rects IsNot Nothing Then
            For Each rect In rects
                g.FillRectangle(Brushes.Bisque, rect)
            Next

            ' Now paint the selected one over.
            If selectedRectIndex <> -1 Then
                g.FillRectangle(New SolidBrush(Color.FromArgb(65, 160, 130, 170)), rects(selectedRectIndex))
            End If
        End If
    End Sub

    Private Sub selectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles selectButton.Click
        ' Indicate we are selecting
        shouldSelect = True
        shouldDraw = False
    End Sub

    Private Sub drawButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles drawButton.Click
        shouldDraw = True
        shouldSelect = False
    End Sub
End Class
