﻿Public Class DragAndDropGraphicsForm
    Private shouldDraw As Boolean        ' If down, then we are drawing
    Private shiftDown As Boolean
    Private leftMouseDown As Boolean
    Private canvas As Graphics
    Private origin As Point
    Private mp As Point
    Private rbSize As Size



    Private Sub DragAndDropGraphicsForm_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If e.KeyCode = Keys.ShiftKey Then
            shiftDown = True
        End If
    End Sub

    Private Sub DragAndDropGraphicsForm_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
        If e.KeyCode = Keys.ShiftKey Then
            shiftDown = False
        End If
    End Sub

    Private Sub DragAndDropGraphicsForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        canvas = Me.CreateGraphics
        Me.DoubleBuffered = True
    End Sub

    Private Sub DragAndDropGraphicsForm_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        If MouseButtons = Windows.Forms.MouseButtons.Left Then
            leftMouseDown = True
        End If

        If shiftDown AndAlso leftMouseDown Then
            ' Means we are drawing, so capture origin point.
            mp = e.Location
            origin = mp
        End If
    End Sub

    Private Sub DragAndDropGraphicsForm_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        If shiftDown AndAlso leftMouseDown Then
            shouldDraw = True
        End If

        If shouldDraw Then
            ' clear old rubber band. The 2 added pixels account for the rubber
            ' banding that encloses the rectangle.
            rbSize.Width = mp.X - origin.X + 1
            rbSize.Height = mp.Y - origin.Y + 1
            canvas.DrawRectangle(SystemPens.Control, New Rectangle(origin, rbSize))
            mp = e.Location

            ' paint new one.
            rbSize.Width = mp.X - origin.X + 1
            rbSize.Height = mp.Y - origin.Y + 1
            canvas.DrawRectangle(Pens.Green, New Rectangle(origin, rbSize))

        End If
    End Sub

    Private Sub DragAndDropGraphicsForm_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        ' clear the rubber band.
        'canvas.DrawRectangle(SystemPens.Control, New Rectangle(origin, rbSize))

        If shouldDraw Then
            ' Done drawing current rectangle, so fill it in.
            rbSize.Width += 1
            rbSize.Height += 1

            canvas.FillRectangle(Brushes.Cyan, New Rectangle(origin, rbSize))

            ' update the origin.
            'origin = mp
        End If

        If MouseButtons = Windows.Forms.MouseButtons.None Then
            leftMouseDown = False
        End If

    End Sub
End Class
