﻿Imports System.IO


Public Class ImageViewerFromDisk
    Private imagePaths() As String
    Private currentIndex As Int32 = 0

    Private Sub DisplayNext()
        currentIndex += 1
        If currentIndex = imagePaths.GetUpperBound(0) + 1 Then
            currentIndex = 0
        End If
        imagePictureBox.ImageLocation = imagePaths(currentIndex)
    End Sub

    Private Sub DisplayPrevious()
        currentIndex -= 1
        If currentIndex = -1 Then
            currentIndex = imagePaths.GetUpperBound(0)
        End If
        imagePictureBox.ImageLocation = imagePaths(currentIndex)
    End Sub


    Private Sub ImageViewer_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
        If e.KeyCode = Keys.Right Then
            DisplayNext()
        ElseIf e.KeyCode = Keys.Left Then
            DisplayPrevious()
        End If
    End Sub

    Private Sub nextButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nextButton.Click
        DisplayNext()
    End Sub

    Private Sub previousButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles previousButton.Click
        DisplayPrevious()
    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        ' Present the user with a folder browser dialog, so they may specify the folder to view.
        With imageFolderBrowserDialog
            If .ShowDialog() = DialogResult.OK Then
                ' Load the image paths in the selected folder.
                imagePaths = Directory.GetFiles(CStr(.SelectedPath), "*.jpg")

                ' Now load the first image into the picture box.
                imagePictureBox.ImageLocation = imagePaths(currentIndex)
            End If
        End With
    End Sub
End Class