﻿Public Class ListHandlingForm

    Private Sub LoadComboBox()
        With deptComboBox.Items
            .Add("WP")
            .Add("IT")
            .Add("ACCT")
        End With
        deptComboBox.SelectedIndex = 1
    End Sub


    Private Sub ClearTextBoxes()
        firstTextBox.Clear()
        lastTextBox.Clear()
        salaryTextBox.Clear()
    End Sub

    Private Sub exitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exitButton.Click
        Me.Close()
    End Sub

    Private Sub ListHandlingForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadComboBox()
    End Sub

    Private Sub addButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles addButton.Click
        ' enable the listbox.
        nameListBox.Enabled = True

        ' add the items to the listbox.
        With nameListBox.Items
            .Add(firstTextBox.Text &
                 " " &
                 lastTextBox.Text &
                 " " &
                 salaryTextBox.Text &
                  " " &
                 deptComboBox.Text)
        End With

        firstTextBox.Focus()
        ClearTextBoxes()
        deptComboBox.SelectedText = "IT"
    End Sub

    Private Sub allTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles salaryTextBox.TextChanged, lastTextBox.TextChanged, firstTextBox.TextChanged
        addButton.Enabled = firstTextBox.TextLength > 0 AndAlso
                            lastTextBox.TextLength > 0 AndAlso
                            salaryTextBox.TextLength > 0
    End Sub

    Private Sub nameListBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles nameListBox.Click
        removeButton.Enabled = True
    End Sub

    Private Sub nameListBox_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles nameListBox.GotFocus
        removeButton.Enabled = True
    End Sub

    Private Sub nameListBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nameListBox.SelectedIndexChanged
        'removeButton.Enabled = True
    End Sub

    Private Sub sortedCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles sortedCheckBox.CheckedChanged
        Dim chk As CheckBox = CType(sender, CheckBox)

        nameListBox.Sorted = chk.Checked
    End Sub

    Private Sub multiSelectCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles multiSelectCheckBox.CheckedChanged
        Dim chk As CheckBox = CType(sender, CheckBox)

        If chk.Checked Then
            nameListBox.SelectionMode = SelectionMode.MultiExtended
        Else
            nameListBox.SelectionMode = SelectionMode.One
        End If
    End Sub

    Private Sub removeButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles removeButton.Click


        ' Incorrent way to select the items.
        For i As Int32 = 0 To nameListBox.SelectedIndices.Count - 1
            nameListBox.Items.RemoveAt(nameListBox.SelectedIndices(i))
        Next

        ' Correct way to remove all items that are selected.
        'For i As Int32 = nameListBox.SelectedIndices.Count - 1 To 0 Step -1
        '    nameListBox.Items.RemoveAt(nameListBox.SelectedIndices(i))
        'Next

        If nameListBox.Items.Count > 0 Then
            nameListBox.Enabled = False
        Else
            nameListBox.Enabled = True
        End If
    End Sub
End Class
