﻿Imports System.IO

Public Class InheriranceForm
    Dim students(99) As Student


    Private Sub LoadArrayFromFile(ByVal sr As StreamReader)
        Dim record As String
        Dim fields() As String
        Dim index As Integer

        Do While Not sr.EndOfStream
            record = sr.ReadLine()
            fields = record.Split(","c)

            Select Case fields(0).ToUpper
                Case "U"
                    students(index) = New Undergraduate(
                        fields(1), fields(2), fields(3), fields(4), fields(5))
                Case "G"
                    students(index) = New Graduate(
                        fields(1), fields(2), fields(3), CBool(fields(4)))
            End Select
            index += 1
        Loop
        ReDim Preserve students(index - 1)
    End Sub


    Private Sub LoadListBoxWithArray()
        ' Load the first and last names into the list box.
        For Each aStudent In students
            With studentNameListBox.Items
                .Add(aStudent.LastName & ", " & aStudent.FirstName)
            End With
        Next

        ' Select the first student.
        studentNameListBox.SelectedIndex = 0
    End Sub


    Private Sub RefreshControls(ByVal selectedIndex As Integer)
        Dim currentStudent As Student = students(selectedIndex)

        With currentStudent
            firstTextBox.Text = .FirstName()
            lastTextBox.Text = .LastName()
            majorTextBox.Text = .AcademicMajor()

            ' Let's see what type of object we have so we can customize
            ' the output.
            If TypeOf currentStudent Is Undergraduate Then
                Dim undergrad As Undergraduate = CType(currentStudent, Undergraduate)

                With undergrad
                    minorTextBox.Enabled = True
                    minorTextBox.Text = .AcademicMinor

                    yearTextBox.Enabled = True
                    yearTextBox.Text = .AcademicYear
                    undergraduateRadioButton.Checked = True

                    ' Uncheck and disable the thesis checkbox
                    thesisCheckBox.Checked = False
                    thesisCheckBox.Enabled = False
                End With
            Else
                Dim grad As Graduate = CType(currentStudent, Graduate)

                With grad
                    thesisCheckBox.Enabled = True
                    thesisCheckBox.Checked = .ThesisOption
                    graduateRadioButton.Checked = True

                    ' Clear and disable the minor textbox.
                    minorTextBox.Clear()
                    minorTextBox.Enabled = False

                    ' Clear and disable the year textbox.
                    yearTextBox.Clear()
                    yearTextBox.Enabled = False
                End With
            End If
        End With
    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        ' Open the file and load the array.
        With OpenFileDialog
            .InitialDirectory = Application.StartupPath
            .FileName = "*.txt"

            If .ShowDialog() <> DialogResult.Cancel Then
                Dim sr As StreamReader = New StreamReader(.FileName)
                LoadArrayFromFile(sr)
                sr.Close()

                ' Load the listbox
                LoadListBoxWithArray()

                ' Enable both of the groupboxes.
                studentDisplayGroupBox.Enabled = True
                studentRecordGroupBox.Enabled = True
            End If
        End With

        studentNameListBox.Focus()
    End Sub

    Private Sub exitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exitButton.Click
        ' Close the form
        Me.Close()
    End Sub
   

    Private Sub studentNameListBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles studentNameListBox.SelectedIndexChanged
        ' Refresh the controls.
        RefreshControls(CType(sender, ListBox).SelectedIndex)
    End Sub
End Class
