﻿Public Class LINQEmployeeForm
    Private employees() As Employee = {
        New Employee("Jason", "Red", 5000D),
        New Employee("Ashley", "Green", 7600D),
        New Employee("Matthew", "Indigo", 3587.5D),
        New Employee("James", "Indigo", 4700.77D),
        New Employee("Luke", "Indigo", 6200D),
        New Employee("Jason", "Blue", 3200D),
        New Employee("Wendy", "Brown", 4236.4D)}


    Public Sub ListAllEmployees()
        Dim original =
        From employee In employees
        Select employee

        outputTextBox.AppendText(String.Format(
            "{0}Original array:{0}", vbCrLf))
        For Each value In original
            outputTextBox.AppendText(String.Format(
                "{0}{1}", value, vbCrLf))
        Next
    End Sub

    Public Sub ListEmployeesWithSalaryInRange(ByVal fromSalary As Decimal,
                                              ByVal toSalary As Decimal)
        Dim between4k6k =
            From employee In employees
            Where employee.MonthlySalary >= fromSalary AndAlso
                  employee.MonthlySalary <= toSalary
            Select employee

        outputTextBox.AppendText(String.Format(
            "{0}Employees earning in the range {1:C}-{2:C} per month:{0}",
            vbCrLf, fromSalary, toSalary))
        For Each value In between4k6k
            outputTextBox.AppendText(String.Format(
                "{0}{1}", value, vbCrLf))
        Next
    End Sub

    Public Sub ListFirstEmployeeByLastName()
        Dim nameSorted =
            From employee In employees
            Order By employee.LastName, employee.FirstName
            Select employee

        outputTextBox.AppendText(String.Format(
                    "{0}First employee when sorted by name:{0}", vbCrLf))
        If nameSorted.Count() > 0 Then
            outputTextBox.AppendText(nameSorted.First().ToString() & vbCrLf)
        Else
            outputTextBox.AppendText("not found" & vbCrLf)
        End If
    End Sub


    Public Sub ListAllDistictLastNames()
        Dim lastNames =
            From employee In employees
            Select employee.LastName
            Distinct

        outputTextBox.AppendText(String.Format(
            "{0}Unique employee last names:{0}", vbCrLf))
        For Each value In lastNames
            outputTextBox.AppendText(String.Format(
                "{0}{1}", value, vbCrLf))
        Next
    End Sub


    Public Sub ListOnlyEmployeeNames()
        Dim names =
            From employee In employees
            Select employee.FirstName, employee.LastName

        outputTextBox.AppendText(String.Format(
            "{0}Employee names only:{0}", vbCrLf))
        For Each value In names
            outputTextBox.AppendText(String.Format(
                "{0}{1}", value, vbCrLf))
        Next
    End Sub

    Private Sub allEmployeesButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles allEmployeesButton.Click
        ' List the original array values.
        ListAllEmployees()
    End Sub

    Private Sub fourToSixKButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles fourToSixKButton.Click
        ' List employees with salalry 4K to 6k.
        ListEmployeesWithSalaryInRange(4000, 6000)
    End Sub

    Private Sub firstEmployeeButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles firstEmployeeButton.Click
        ' List the first employee by last name.
        ListFirstEmployeeByLastName()
    End Sub

    Private Sub distinctLastNameButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles distinctLastNameButton.Click
        ' List only the distict last names.
        ListAllDistictLastNames()
    End Sub

    Private Sub namesOnlyButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles namesOnlyButton.Click
        ' List just the employee names.
        ListOnlyEmployeeNames()
    End Sub
End Class
