﻿Public Class LINQQueriesForm
    Private values() As Integer = {2, 9, 5, 0, 3, 7, 1, 4, 8, 6}

    Public Sub ListOriginalValues()
        Dim original =
            From element In values
            Select element

        outputTextBox.AppendText(String.Format("Original array:{0}", vbCrLf))
        For Each element In original
            outputTextBox.AppendText(String.Format("{0,3}", element))
        Next
    End Sub

    Public Sub ListValuesGreaterThan(ByVal value As Integer)
        Dim filtered =
            From element In values
            Where element > value
            Select element

        outputTextBox.AppendText(String.Format(
            "{0}{0}Array values greater than {1}:{0}", vbCrLf, value))
        For Each element In filtered
            outputTextBox.AppendText(String.Format("{0,3}", element))
        Next
    End Sub

    Public Sub ListSortedOriginalValues()
        Dim sorted =
            From element In values
            Order By element
            Select element

        outputTextBox.AppendText(String.Format(
            "{0}{0}Original array, sorted:{0}", vbCrLf))
        For Each element In sorted
            outputTextBox.AppendText(String.Format("{0,3}", element))
        Next
    End Sub

    Public Sub ListSortedFilteredValuesGreaterThan(ByVal value As Integer)
        Dim filtered =
            From element In values
            Where element > value
            Select element

        Dim sortFilteredResults =
            From element In filtered
            Order By element Descending
            Select element

        outputTextBox.AppendText(String.Format(
            "{0}{0}Values greater than {1}, descending order (chained):{0}",
            vbCrLf, value))
        For Each element In sortFilteredResults
            outputTextBox.AppendText(String.Format("{0,3}", element))
        Next
    End Sub

    Public Sub ListSortedValuesGreaterThan(ByVal value As Integer)
        Dim sortAndFilter =
            From element In values
            Where element > value
            Order By element Descending
            Select element

        outputTextBox.AppendText(String.Format(
            "{0}{0}Values greater than {1}, descending order (one query):{0}",
            vbCrLf, value))
        For Each element In sortAndFilter
            outputTextBox.AppendText(String.Format("{0,3}", element))
        Next
    End Sub


    Private Sub LINQQueriesForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' List the original values.
        ListOriginalValues()

        ' List values greater than 4.
        ListValuesGreaterThan(4)

        ' List original values sorted in ascending order.
        ListSortedOriginalValues()

        ' List values greater than 4, then sorted in descending order.
        ListSortedFilteredValuesGreaterThan(4)

        ' List values greater than 4 sorted in descending order.
        ListSortedValuesGreaterThan(4)
    End Sub
End Class
