﻿Public Class TitleQueries
    Private database As New BooksDataContext


    Private Sub TitleBindingNavigatorSaveItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TitleBindingNavigatorSaveItem.Click
        Validate()
        TitleBindingSource.EndEdit()
        database.SubmitChanges()
    End Sub

    Private Sub TitleQueries_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        allTitlesButton.PerformClick()

        ' Load the copyright textbox with the first copyright year.
        copyrightTextBox.Text = database.Titles.First.Copyright
    End Sub

    Private Sub allTitlesButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles allTitlesButton.Click
        TitleBindingSource.DataSource =
            From book In database.Titles
            Order By book.ISBN
            Select book
    End Sub

    Private Sub copyrightButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles copyrightButton.Click
        TitleBindingSource.DataSource =
            From book In database.Titles
            Where book.Copyright = copyrightTextBox.Text
            Order By book.ISBN
            Select book
    End Sub

    Private Sub howToProgramButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles howToProgramButton.Click
        TitleBindingSource.DataSource =
            From book In database.Titles
            Where book.Title.EndsWith("How to Program")
            Select book
    End Sub

    Private Sub copyrightTextBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles copyrightTextBox.Click
        CType(sender, TextBox).SelectAll()
    End Sub

    'Private Sub copyrightTextBox_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles copyrightTextBox.GotFocus
    '    'CType(sender, TextBox).SelectAll()
    'End Sub
End Class
