﻿Public Class JoiningTableData
    Private database As New BooksDataContext
    

    Private Sub authorsAndIsbnsButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles authorsAndIsbnsButton.Click
        Dim authorsAndISBNs =
            From author In database.Authors
            From book In author.AuthorISBNs
            Order By author.LastName, author.FirstName
            Select author.FirstName, author.LastName, book.ISBN

        outputTextBox.AppendText(vbCrLf & "Authors and ISBNs:")
        For Each element In authorsAndISBNs
            outputTextBox.AppendText(String.Format(
                "{0}{1}{2,-10} {3,-10} {4,-10}", vbCrLf, vbTab,
                element.FirstName, element.LastName, element.ISBN))
        Next

        authorsAndIsbnsButton.Enabled = False
    End Sub

    Private Sub authorsAndTitlesButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles authorsAndTitlesButton.Click
        Dim authorsAndTitles =
            From title In database.Titles
            From book In title.AuthorISBNs
            Let author = book.Author
            Order By title.Title, author.LastName, author.FirstName
            Select author.FirstName, author.LastName, title.Title

        outputTextBox.AppendText(vbCrLf & vbCrLf & "Titles and their authors")
        For Each element In authorsAndTitles
            outputTextBox.AppendText(String.Format(
                "{0}{1}{2,-10} {3,-10} {4}", vbCrLf, vbTab,
                element.FirstName, element.LastName, element.Title))
        Next
        authorsAndTitlesButton.Enabled = False
    End Sub

    Private Sub titlesGroupedByAuthorButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles titlesGroupedByAuthorButton.Click
        Dim titlesByAuthor =
            From author In database.Authors
            Order By author.LastName, author.FirstName
            Select Name = author.FirstName & " " & author.LastName,
            Titles =
                From book In author.AuthorISBNs
                Order By book.Title.Title
                Select book.Title.Title

        outputTextBox.AppendText(vbCrLf & vbCrLf & "Titles grouped by author:")
        For Each author In titlesByAuthor
            outputTextBox.AppendText(
                String.Format("{0}{1}{2}:", vbCrLf, vbTab, author.Name))

            For Each title In author.Titles
                outputTextBox.AppendText(String.Format("{0}{1}{1}{2}", vbCrLf, vbTab, title))
            Next title
        Next author
        titlesGroupedByAuthorButton.Enabled = False
    End Sub
End Class
