﻿Public Class DetailsForm
    Private database As New BooksDataContext

    ' Class to combine the author's first and last names, for easier display in
    ' the combo box.
    Private Class AuthorBinding
        Public Property Author As Author
        Public Property Name As String
    End Class


    Private Sub DetailsForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        authorComboBox.DisplayMember = "Name"     ' AuthorBinding.Name

        authorComboBox.DataSource =
            From author In database.Authors
            Order By author.LastName, author.FirstName
            Select New AuthorBinding With
                   {
                       .Author = author,
                       .Name = author.FirstName & " " & author.LastName
                   }

        authorComboBox.SelectedIndex = -1

        titleComboBox.DisplayMember = "Title"
        titleComboBox.DataSource =
            From title In database.Titles
            Order By title.Title
            Select title

        titleComboBox.SelectedIndex = -1
        booksDataGridView.DataSource = Nothing
    End Sub

    Private Sub authorComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles authorComboBox.SelectedIndexChanged
        If authorComboBox.SelectedIndex <> -1 Then
            Dim currentAuthor As Author =
                CType(authorComboBox.SelectedItem, AuthorBinding).Author

            titleBindingSource.DataSource =
                From book In currentAuthor.AuthorISBNs
                Select book.Title

            booksDataGridView.DataSource = titleBindingSource
            booksDataGridView.Columns(1).AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
        End If
    End Sub

    Private Sub titleComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles titleComboBox.SelectedIndexChanged
        If titleComboBox.SelectedIndex <> -1 Then
            Dim currentTitle As Title =
                CType(titleComboBox.SelectedItem, Title)

            authorBindingSource.DataSource =
                From book In currentTitle.AuthorISBNs
                Select book.Author

            booksDataGridView.DataSource = authorBindingSource

        End If
    End Sub
End Class
