﻿Public Class MoreGraphicsForm
    Private shouldDraw As Boolean
    Private startPt As Point
    Private endPt As Point
    Private drawPath As New Drawing2D.GraphicsPath



    Private Sub MoreGraphicsForm_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseClick
        If e.Button = MouseButtons.Left Then
            If shouldDraw Then
                Using g As Graphics = CreateGraphics()
                    g.DrawLine(New Pen(Control.DefaultBackColor), startPt, endPt)
                    drawPath.AddLine(startPt, endPt)
                    g.DrawPath(Pens.Black, drawPath)
                End Using
                startPt = endPt
            Else
                shouldDraw = True
                startPt = New Point(e.X, e.Y)
            End If
        Else
            Using g As Graphics = CreateGraphics()
                g.DrawLine(New Pen(Control.DefaultBackColor), startPt, endPt)
                shouldDraw = False
            End Using
            ' Prevent new figure from being connected to the previous one.
            ' Normally the first new point will connect to the old last point.
            drawPath.StartFigure()
        End If
    End Sub



    Private Sub MoreGraphicsForm_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        If (shouldDraw) Then
            Using g As Graphics = CreateGraphics()

                g.DrawLine(New Pen(Control.DefaultBackColor), startPt, endPt)
                g.DrawPath(Pens.Black, drawPath)
                endPt = New Point(e.X, e.Y)
                g.DrawLine(Pens.Black, startPt, endPt)
            End Using
        End If
    End Sub

    Private Sub MoreGraphicsForm_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        Using g As Graphics = CreateGraphics()
            g.DrawPath(Pens.Black, drawPath)
        End Using
    End Sub
End Class
